#include "stdafx.h"

#include "Util.h"
#include "BkBsfilProfile.h"

////////////////////////////////////////////////////////////////////////
// ݒ̃x[XNX
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

BkBsfilProfileBase::BkBsfilProfileBase() :
	m_pcsProfile(0)
{
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

BkBsfilProfileBase::~BkBsfilProfileBase()
{
}

//----------------------------------------------------------------------
// rp̃IuWFNgݒ肷
//----------------------------------------------------------------------

void BkBsfilProfileBase::SetLockObject(CRITICAL_SECTION* pcsProfile)
{
	m_pcsProfile = pcsProfile;
}

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒ
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

BkBsfilProfile::BkBsfilProfile()
{
}

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------

void BkBsfilProfile::Initialize()
{
	m_procSpam = GoTrash;
	m_spamFolder = "";
	m_goFolderSameRelativeFolderPath = false;
	m_spamHeaderFieldName = "BkBsfilWrapper";
	m_spamHeaderFieldBody = "spam";
	m_setReadToSpamMail = false;
	m_dontCheckDbOnStart = false;
	m_disableBeforeMsgbox = false;
	m_disableResultMsgbox = false;
	m_addToAddrToWhiteListOnSend = false;
	m_dontRemoveSpamHeader = false;
	m_logLevel = "ERROR";
}

//----------------------------------------------------------------------
// ݒǂݏ
//----------------------------------------------------------------------

void BkBsfilProfile::ProfileRW(CBkBsfilProfileManager& profManager, BOOL isWrite)
{
	std::string section;
	std::string key;
	std::string itemValue;
	
	//
	// BkBsfilWrapper ̐ݒ
	//
	section = "BkBsfilWrapper";

	// spam Ɣ肳ꂽ[̏u
	key = "ProcessSpamMail";
	itemValue = "";
	if (isWrite) {
		switch (m_procSpam) {
		case NoMove:
			itemValue = "NoMove";
			break;
		case GoFolder:
			itemValue = "GoFolder";
			break;
		case AddHeader:
			itemValue = "AddHeader";
			break;
		case GoTrash:
		default:
			itemValue = "GoTrash";
			break;
		}
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);

		if (_stricmp(itemValue.c_str(), "NoMove") == 0) {
			m_procSpam = NoMove;
		} else if (_stricmp(itemValue.c_str(), "GoFolder") == 0) {
			m_procSpam = GoFolder;
		} else if (_stricmp(itemValue.c_str(), "AddHeader") == 0) {
			m_procSpam = AddHeader;
		} else {
			m_procSpam = GoTrash;
		}
	}

	// uwtH_ցv̏ꍇ̃tH_
	key = "SpamFolder";
	profManager.ItemRW(section, key, m_spamFolder);

	// uwb_tv̏ꍇ̃wb_
	key = "SpamHeaderFieldName";
	profManager.ItemRW(section, key, m_spamHeaderFieldName);

	key = "SpamHeaderFieldBody";
	profManager.ItemRW(section, key, m_spamHeaderFieldBody);

	// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
	key = "GoFolderSameRelativeFolderPath";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_goFolderSameRelativeFolderPath);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_goFolderSameRelativeFolderPath = Util::GetBoolean(itemValue);
	}

	// spam Ɣ肳ꂽ[͊ǂɂ
	key = "SetReadToSpamMail";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_setReadToSpamMail);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_setReadToSpamMail = Util::GetBoolean(itemValue);
	}

	// N bsfilter f[^x[XQƂȂ
	key = "DontCheckDbOnStart";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_dontCheckDbOnStart);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_dontCheckDbOnStart = Util::GetBoolean(itemValue);
	}

	// OɃbZ[W{bNX\Ȃ
	key = "DisableBeforeMsgbox";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_disableBeforeMsgbox);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_disableBeforeMsgbox = Util::GetBoolean(itemValue);
	}

	// ʕ\̃bZ[W{bNX\Ȃ
	key = "DisableResultMsgbox";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_disableResultMsgbox);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_disableResultMsgbox = Util::GetBoolean(itemValue);
	}

	// MɃzCgXgɒǉ
	key = "AddToAddrToWhiteListOnSend";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_addToAddrToWhiteListOnSend);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_addToAddrToWhiteListOnSend = Util::GetBoolean(itemValue);
	}

	// 莞у[wK clean ȃ[ spam wb_Ȃ
	key = "DontRemoveSpamHeader";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_dontRemoveSpamHeader);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_dontRemoveSpamHeader = Util::GetBoolean(itemValue);
	}
	
	// Ox
	key = "LogLevel";
	if (isWrite) {
		// ܂Ȃ
	} else {
		profManager.ItemRW(section, key, m_logLevel);
	}
}

//----------------------------------------------------------------------
// spam Ɣ肳ꂽ[̏u
//----------------------------------------------------------------------

BkBsfilProfile::ProcessSpamMail BkBsfilProfile::GetProcSpam()
{
	CSLock cslock(m_pcsProfile);
	return m_procSpam;
}

void BkBsfilProfile::SetProcSpam(BkBsfilProfile::ProcessSpamMail procSpam)
{
	CSLock cslock(m_pcsProfile);
	m_procSpam = procSpam;
}

//----------------------------------------------------------------------
// uwtH_ցv̏ꍇ̃tH_
//----------------------------------------------------------------------

std::string BkBsfilProfile::GetSpamFolder()
{
	CSLock cslock(m_pcsProfile);
	return m_spamFolder;
}

void BkBsfilProfile::SetSpamFolder(std::string spamFolder)
{
	CSLock cslock(m_pcsProfile);
	m_spamFolder = spamFolder;
}

//----------------------------------------------------------------------
// uwb_tv̏ꍇ̃wb_
//----------------------------------------------------------------------

std::string BkBsfilProfile::GetSpamHeaderFieldName()
{
	CSLock cslock(m_pcsProfile);

	std::string spamHeaderFieldName;
	if (NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX < m_spamHeaderFieldName.length()) {
		spamHeaderFieldName = m_spamHeaderFieldName.substr(0, NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX);
	} else {
		spamHeaderFieldName = m_spamHeaderFieldName;
	}

	return spamHeaderFieldName;
}

void BkBsfilProfile::SetSpamHeaderFieldName(std::string spamHeaderFieldName)
{
	CSLock cslock(m_pcsProfile);

	if (NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX < spamHeaderFieldName.length()) {
		m_spamHeaderFieldName = spamHeaderFieldName.substr(0, NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX);
	} else {
		m_spamHeaderFieldName = spamHeaderFieldName;
	}
}

std::string BkBsfilProfile::GetSpamHeaderFieldBody()
{
	CSLock cslock(m_pcsProfile);

	std::string spamHeaderFieldBody;
	if (NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX < m_spamHeaderFieldBody.length()) {
		spamHeaderFieldBody = m_spamHeaderFieldBody.substr(0, NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX);
	} else {
		spamHeaderFieldBody = m_spamHeaderFieldBody;
	}

	return spamHeaderFieldBody;
}

void BkBsfilProfile::SetSpamHeaderFieldBody(std::string spamHeaderFieldBody)
{
	CSLock cslock(m_pcsProfile);

	if (NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX < spamHeaderFieldBody.length()) {
		m_spamHeaderFieldBody = spamHeaderFieldBody.substr(0, NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX);
	} else {
		m_spamHeaderFieldBody = spamHeaderFieldBody;
	}
}

//----------------------------------------------------------------------
// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetGoFolderSameRelativeFolderPath()
{
	CSLock cslock(m_pcsProfile);
	return m_goFolderSameRelativeFolderPath;
}

void BkBsfilProfile::SetGoFolderSameRelativeFolderPath(bool goFolderSameRelativeFolderPath)
{
	CSLock cslock(m_pcsProfile);
	m_goFolderSameRelativeFolderPath = goFolderSameRelativeFolderPath;
}

//----------------------------------------------------------------------
// spam Ɣ肳ꂽ[͊ǂɂ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetSetReadToSpamMail()
{
	CSLock cslock(m_pcsProfile);
	return m_setReadToSpamMail;
}

void BkBsfilProfile::SetSetReadToSpamMail(bool setReadToSpamMail)
{
	CSLock cslock(m_pcsProfile);
	m_setReadToSpamMail = setReadToSpamMail;
}

//----------------------------------------------------------------------
// OɃbZ[W{bNX\Ȃ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetDisableBeforeMsgbox()
{
	CSLock cslock(m_pcsProfile);
	return m_disableBeforeMsgbox;
}

void BkBsfilProfile::SetDisableBeforeMsgbox(bool disableBeforeMsgbox)
{
	CSLock cslock(m_pcsProfile);
	m_disableBeforeMsgbox = disableBeforeMsgbox;
}

//----------------------------------------------------------------------
// ʕ\̃bZ[W{bNX\Ȃ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetDisableResultMsgbox()
{
	CSLock cslock(m_pcsProfile);
	return m_disableResultMsgbox;
}

void BkBsfilProfile::SetDisableResultMsgbox(bool disableResultMsgbox)
{
	CSLock cslock(m_pcsProfile);
	m_disableResultMsgbox = disableResultMsgbox;
}

//----------------------------------------------------------------------
// N bsfilter f[^x[XQƂȂ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetDontCheckDbOnStart()
{
	CSLock cslock(m_pcsProfile);
	return m_dontCheckDbOnStart;
}

void BkBsfilProfile::SetDontCheckDbOnStart(bool dontCheckDbOnStart)
{
	CSLock cslock(m_pcsProfile);
	m_dontCheckDbOnStart = dontCheckDbOnStart;
}

//----------------------------------------------------------------------
// MɃzCgXgɒǉ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetAddToAddrToWhiteListOnSend()
{
	CSLock cslock(m_pcsProfile);
	return m_addToAddrToWhiteListOnSend;
}

void BkBsfilProfile::SetAddToAddrToWhiteListOnSend(bool addToAddrToWhiteListOnSend)
{
	CSLock cslock(m_pcsProfile);
	m_addToAddrToWhiteListOnSend = addToAddrToWhiteListOnSend;
}

//----------------------------------------------------------------------
// 莞у[wK clean ȃ[ spam wb_Ȃ
//----------------------------------------------------------------------

bool BkBsfilProfile::GetDontRemoveSpamHeader()
{
	CSLock cslock(m_pcsProfile);
	return m_dontRemoveSpamHeader;
}

void BkBsfilProfile::SetDontRemoveSpamHeader(bool dontRemoveSpamHeader)
{
	CSLock cslock(m_pcsProfile);
	m_dontRemoveSpamHeader = dontRemoveSpamHeader;
}

//----------------------------------------------------------------------
// Ox
//----------------------------------------------------------------------

std::string BkBsfilProfile::GetLogLevel()
{
	CSLock cslock(m_pcsProfile);
	return m_logLevel;
}

void BkBsfilProfile::SetLogLevel(std::string logLevel)
{
	CSLock cslock(m_pcsProfile);
	m_logLevel = logLevel;
}

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒ(p)
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

BkBsfilProfileEnv::BkBsfilProfileEnv() :
	m_bAscending(true),
	m_addrTypeItemWidth(0),
	m_emailAddrItemWidth(0),
	m_noteItemWidth(0)
{
}

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------

void BkBsfilProfileEnv::Initialize()
{
	m_sortItemName = "AddrType";
	m_bAscending = true;
	m_addrTypeItemWidth = 24;
	m_emailAddrItemWidth = 256;
	m_noteItemWidth = 180;
}

//----------------------------------------------------------------------
// ݒǂݏ
//----------------------------------------------------------------------

void BkBsfilProfileEnv::ProfileRW(CBkBsfilProfileManager& profManager, BOOL isWrite)
{
	std::string section;
	std::string key;
	std::string itemValue;

	//
	// zCgXg UI ̐ݒ
	//
	section = "WhiteListUISettings";

	// \[g
	key = "SortItemName";
	itemValue = "";
	profManager.ItemRW(section, key, m_sortItemName);

	// \[g
	key = "SortIsAscending";
	itemValue = "";
	if (isWrite) {
		itemValue = Util::GetBooleanStr(m_bAscending);
		profManager.ItemRW(section, key, itemValue);
	} else {
		profManager.ItemRW(section, key, itemValue);
		m_bAscending = Util::GetBoolean(itemValue, true);
	}

	// ڕ(AhX̎)
	key = "AddrTypeItemWidth";
	profManager.ItemRW(section, key, m_addrTypeItemWidth);

	// ڕ([AhX)
	key = "EmailAddrItemWidth";
	profManager.ItemRW(section, key, m_emailAddrItemWidth);

	// ڕ(l)
	key = "NoteItemWidth";
	profManager.ItemRW(section, key, m_noteItemWidth);
}

//----------------------------------------------------------------------
// \[g
//----------------------------------------------------------------------

WhiteList::SortKey BkBsfilProfileEnv::GetSortKey()
{
	CSLock cslock(m_pcsProfile);
	
	if (_stricmp(m_sortItemName.c_str(), "AddrType") == 0) {
		return  WhiteList::SortAddrType;
	} else if (_stricmp(m_sortItemName.c_str(), "EmailAddr") == 0) {
		return WhiteList::SortEmailAddr;
	} else if (_stricmp(m_sortItemName.c_str(), "Note") == 0) {
		return WhiteList::SortNote;
	}

	return  WhiteList::SortAddrType;
}

void BkBsfilProfileEnv::SetSortKey(WhiteList::SortKey sortKey)
{
	CSLock cslock(m_pcsProfile);

	std::string sortItemName;
	switch (sortKey) {
	case WhiteList::SortAddrType:
	default:
		sortItemName = "AddrType";
		break;
	case WhiteList::SortEmailAddr:
		sortItemName = "EmailAddr";
		break;
	case WhiteList::SortNote:
		sortItemName = "Note";
		break;
	}

	m_sortItemName = sortItemName;
}

//----------------------------------------------------------------------
// \[g
//----------------------------------------------------------------------

bool BkBsfilProfileEnv::IsAscending()
{
	CSLock cslock(m_pcsProfile);
	return m_bAscending;
}

void BkBsfilProfileEnv::SetAscending(bool bAscending)
{
	CSLock cslock(m_pcsProfile);
	m_bAscending = bAscending;
}

//----------------------------------------------------------------------
// ڕ(AhX̎)
//----------------------------------------------------------------------

int BkBsfilProfileEnv::GetAddrTypeItemWidth()
{
	CSLock cslock(m_pcsProfile);
	return m_addrTypeItemWidth;
}

void BkBsfilProfileEnv::SetAddrTypeItemWidth(int width)
{
	CSLock cslock(m_pcsProfile);
	m_addrTypeItemWidth = width;
}

//----------------------------------------------------------------------
// ڕ([AhX)
//----------------------------------------------------------------------

int BkBsfilProfileEnv::GetEmailAddrItemWidth()
{
	CSLock cslock(m_pcsProfile);
	return m_emailAddrItemWidth;
}

void BkBsfilProfileEnv::SetEmailAddrItemWidth(int width)
{
	CSLock cslock(m_pcsProfile);
	m_emailAddrItemWidth = width;
}

//----------------------------------------------------------------------
// ڕ(l)
//----------------------------------------------------------------------

int BkBsfilProfileEnv::GetNoteItemWidth()
{
	CSLock cslock(m_pcsProfile);
	return m_noteItemWidth;
}

void BkBsfilProfileEnv::SetNoteItemWidth(int width)
{
	CSLock cslock(m_pcsProfile);
	m_noteItemWidth = width;
}

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ݒ̓ǂݏs
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CBkBsfilProfileManager::CBkBsfilProfileManager() :
	m_isWrite(false)
{
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CBkBsfilProfileManager::~CBkBsfilProfileManager()
{
}

//----------------------------------------------------------------------
// ݒ[h
//----------------------------------------------------------------------

void CBkBsfilProfileManager::Load(BkBsfilProfileBase& bkBsfilProf, std::string filepath)
{
	m_filepath = filepath;
	m_isWrite = false;

	bkBsfilProf.Initialize();
	bkBsfilProf.ProfileRW(*this, m_isWrite);
}

//----------------------------------------------------------------------
// ݒZ[u
//----------------------------------------------------------------------

void CBkBsfilProfileManager::Save(BkBsfilProfileBase& bkBsfilProf, std::string filepath)
{
	if (0 < filepath.length()) {
		m_filepath = filepath;
	}
	m_isWrite = true;

	bkBsfilProf.ProfileRW(*this, m_isWrite);
}

//----------------------------------------------------------------------
// X̒lǂݏ
//----------------------------------------------------------------------

template <class T>
void CBkBsfilProfileManager::ItemRW(std::string& section, std::string& key, T& value)
{
	if (m_isWrite) {
		WriteItem(section, key, value);
	} else {
		ReadItem(section, key, value, value);
	}
}

//----------------------------------------------------------------------
// lǂ
//----------------------------------------------------------------------

void CBkBsfilProfileManager::ReadItem(std::string& section, std::string& key, std::string& value, std::string defaultValue)
{
	char buffer[1024];
	buffer[0] = '\0';

	GetPrivateProfileString(section.c_str(), key.c_str(), defaultValue.c_str(), buffer, sizeof(buffer), m_filepath.c_str());

	// ݒ肳ĂȂꍇ́AftHglԂB
	// NOTE: GetPrivateProfileString() ́AL[ꍇ̓ftHglԂĂ邪A
	//       L[݂ݒ肳ĂȂꍇ́AL[ɑΉl(󕶎)Ԃ߁A
	//       ftHglŏ㏑B
	std::string kvalue = Util::Trim(buffer);
	if (kvalue.length() <= 0) {
		value = defaultValue;
	} else {
		value = kvalue;
	}
}

void CBkBsfilProfileManager::ReadItem(std::string& section, std::string& key, int& value, int defaultValue)
{
	value = GetPrivateProfileInt(section.c_str(), key.c_str(), defaultValue, m_filepath.c_str());
	if (value == 0) {
		value = defaultValue;
	}
}

//----------------------------------------------------------------------
// l
//----------------------------------------------------------------------

void CBkBsfilProfileManager::WriteItem(std::string& section, std::string& key, std::string value)
{
	WritePrivateProfileString(section.c_str(), key.c_str(), value.c_str(), m_filepath.c_str());
}

void CBkBsfilProfileManager::WriteItem(std::string& section, std::string& key, int value)
{
	char buffer[1024];

	_snprintf(buffer, sizeof(buffer), "%d", value);
	FORCE_ASCIZ(buffer);

	WritePrivateProfileString(section.c_str(), key.c_str(), buffer, m_filepath.c_str());
}
